
/*****************************************************************************
                         E R I N A - L i b r a r y
                                                      ŏIXV 2001/05/23
 ----------------------------------------------------------------------------
         Copyright (C) 2000-2001 Leshade Entis. All rights reserved.
 *****************************************************************************/


#if	!defined(CMPERI_H_INCLUDE)
#define	CMPERI_H_INCLUDE

#include "experi.h"


/*****************************************************************************
                               t@CIuWFNg
 *****************************************************************************/

class	EWriteFileObj
{
public:
	// \z֐
	EWriteFileObj( void ) ;
	// Ŋ֐
	virtual ~EWriteFileObj( void ) ;
	// f[^o
	virtual DWORD Write( const void * ptrBuf, DWORD dwByte ) = 0 ;
	// t@C̒擾
	virtual DWORD GetLength( void ) = 0 ;
	// t@C|C^擾
	virtual DWORD GetPointer( void ) = 0 ;
	// t@C|C^ړ
	virtual void Seek( DWORD dwPointer ) = 0 ;

} ;

class	EWriteFile	: public	EWriteFileObj
{
protected:
	HANDLE	m_hFile ;
	bool	m_flagToClose ;

public:
	EWriteFile( void ) ;
	EWriteFile( HANDLE hFile ) ;
	virtual ~EWriteFile( void ) ;

	bool Open( const char * pszFile ) ;
	void Attach( HANDLE hFile ) ;
	void Close( void ) ;

	virtual DWORD Write( const void * ptrBuf, DWORD dwByte ) ;
	virtual DWORD GetLength( void ) ;
	virtual DWORD GetPointer( void ) ;
	virtual void Seek( DWORD dwPointer ) ;

} ;

class	ERIWriteFile	: public	EWriteFileObj
{
protected:
	EWriteFileObj *	m_pFile ;
	struct	RECORD_INFO
	{
		RECORD_INFO *	pParent ;
		DWORD			dwOffset ;
		DWORD			dwLimit ;
	} ;
	RECORD_INFO *	m_pRecInf ;

public:
	enum	FileID
	{
		fidImage,
		fidSound,
		fidMovie
	} ;

public:
	// \z֐
	ERIWriteFile( void ) ;
	// Ŋ֐
	virtual ~ERIWriteFile( void ) ;
	// bt@CJ
	bool Open( EWriteFileObj * pFile, FileID fidType ) ;
	// bt@C
	void Close( void ) ;
	// wb_R[ho
	bool WriteHeader
		( const ERI_FILE_HEADER & efh, const ERI_INFO_HEADER & eih ) ;
	// R[hJ
	bool DescendRecord( const UINT64 * pRecID ) ;
	// R[h
	void AscendRecord( void ) ;

	virtual DWORD Write( const void * ptrBuf, DWORD dwByte ) ;
	virtual DWORD GetLength( void ) ;
	virtual DWORD GetPointer( void ) ;
	virtual void Seek( DWORD dwPointer ) ;

} ;


/*****************************************************************************
                   OXEK}EReLXg
 *****************************************************************************/

class	RLHEncodeContext
{
protected:
	int		m_nIntBufCount ;	// ԓ̓obt@ɒ~ςĂrbg
	DWORD	m_dwIntBuffer ;		// ԓ̓obt@
	ULONG	m_nBufferingSize ;	// obt@OoCg
	ULONG	m_nBufCount ;		// obt@ɒ~ςĂoCg
	PBYTE	m_ptrBuffer ;		// o̓obt@̐擪ւ̃|C^

	struct	MTF_TABLE
	{
		BYTE	iplt[0x100] ;

		inline void Initialize( void ) ;
		inline int Search( BYTE p ) ;
	} ;
	MTF_TABLE *	m_pMTFTable[0x101] ;	// MTFe[u

	ERINA_HUFFMAN_TREE *	m_pLastHuffmanTree ;
	ERINA_HUFFMAN_TREE *	m_pHuffmanTree[0x101] ;

public:
	// \z֐
	RLHEncodeContext( ULONG nBufferingSize ) ;
	// Ŋ֐
	virtual ~RLHEncodeContext( void ) ;

	// rbgo͂
	int OutNBits( DWORD dwData, int n ) ;
	// K}R[hɕۂ̃rbgvZ
	static inline int TryOutACode( int num ) ;
	// K}R[ho͂
	int OutACode( int num ) ;
	// obt@̓eo͂ċɂ
	int Flushout( void ) ;
	// obt@̓eo͂
	virtual ULONG WriteNextData( const BYTE * ptrBuffer, ULONG nBytes ) = 0 ;

	// OXK}ɕۂ̃TCYirbgjvZ
	static int TryEncodeGammaCodes( const INT * ptrSrc, int nCount ) ;
	// OXK}ɕďo͂
	int EncodeGammaCodes( const INT * ptrSrc, int nCount ) ;

	// RL-MTF-G ̏̕
	void PrepareToEncodeRLMTFGCode( void ) ;
	// RL-MTF-G ɕďo͂
	int EncodeRLMTFGCodes( PBYTE ptrSrc, int nCount ) ;

	// ERINA ̏̕
	void PrepareToEncodeERINACode( void ) ;
	// nt}ŏo͂
	int OutAHuffmanCode( ERINA_HUFFMAN_TREE * tree, int num ) ;
	// nt}ŏo͂
	int OutLengthHuffman( ERINA_HUFFMAN_TREE * tree, int length ) ;
	// ERINA ɕďo͂
	int EncodeERINACodes( const INT * ptrSrc, int nCount ) ;
	// ERINA ɕďo͂
	int EncodeERINACodesSBZL( const SBYTE * ptrSrc, int nCount ) ;
	// ERINA i256Fpjɕďo͂
	int EncodeERINACodes256( const BYTE * ptrSrc, int nCount ) ;

} ;

//
// MTF_TABLE 
//////////////////////////////////////////////////////////////////////////////
inline void RLHEncodeContext::MTF_TABLE::Initialize( void )
{
	for ( int i = 0; i < 0x100; i ++ )
		iplt[i] = (BYTE) i ;
}

//
// e[u̒āAMove To Front s
//////////////////////////////////////////////////////////////////////////////
inline int RLHEncodeContext::MTF_TABLE::Search( BYTE p )
{
	BYTE	lplt, cplt ;
	int		index = 0 ;
	lplt = p ;
	for ( ; ; )
	{
		cplt = iplt[index] ;
		iplt[index ++] = lplt ;
		if ( cplt == p )
			break ;
		lplt = cplt ;
	}
	return	index ;
}

//
// K}R[hɕۂ̃rbgvZ
//////////////////////////////////////////////////////////////////////////////
inline int RLHEncodeContext::TryOutACode( int num )
{
	int	b = 0, c = 1 ;
	num -- ;
	while ( num >= c )
	{
		num -= c ;
		c <<= 1 ;
		b ++ ;
	}
	return	b * 2 + 1 ;
}


/*****************************************************************************
                               kIuWFNg
 *****************************************************************************/

class	ERIEncoder
{
protected:
	ERI_INFO_HEADER		m_EriInfHdr ;			// 摜wb_

	UINT				m_nBlockSize ;			// ubLOTCY
	ULONG				m_nBlockArea ;			// ubNʐ
	ULONG				m_nBlockSamples ;		// ubÑTv
	UINT				m_nChannelCount ;		// `l
	ULONG				m_nWidthBlocks ;		// 摜̕iubNj
	ULONG				m_nHeightBlocks ;		// 摜̍iubNj

	UINT				m_nSrcBytesPerPixel ;	// 1sNZ̃oCg

	PINT				m_ptrColumnBuf ;		// obt@
	PINT				m_ptrLineBuf ;			// sobt@
	PINT				m_ptrBuffer1 ;			// obt@
	PINT				m_ptrBuffer2 ;
	int					m_nChannelDepth ;		// `l̃rbg[x

	PINT				m_pArrangeTable[4] ;	// TvOe[u

	PBYTE				m_ptrOperations ;		// Iy[Ve[u
	PINT				m_ptrDstBuffer ;		// fBXeBl[Vobt@

	ERINA_HUFFMAN_TREE *	m_pHuffmanTree ;	// nt}

public:
	typedef	void (ERIEncoder::*PFUNC_COLOR_OPRATION)( void ) ;
	typedef	void (ERIEncoder::*PFUNC_SAMPLING)
		( PBYTE ptrSrc, LONG nLineBytes, int nWidth, int nHeight ) ;
	typedef	void (ERIEncoder::*PFUNC_SAMPLINGII)
		( REAL32 * ptrBuffer[], PBYTE ptrSrc,
			LONG nLineBytes, int nWidth, int nHeight ) ;
	typedef	void (ERIEncoder::*PFUNC_BLOCK_SCALING)( void ) ;

protected:
	UINT				m_nBlocksetCount ;		// 1ubNZbg̃ubN
	PFUNC_BLOCK_SCALING	m_pfnBlockScaling ;		// ubNXP[O֐

	REAL32 *			m_ptrBuffer3[4][4] ;	// obt@
	REAL32 *			m_ptrBuffer4[16] ;
	REAL32 *			m_ptrBuffer5[16] ;
	REAL32 *			m_ptrWorkDCT1 ;			// DCT ϊpƗ̈
	REAL32 *			m_ptrWorkDCT2 ;
	INT					m_nDCDiffBuffer[16] ;	// DC pobt@

	PINT				m_ptrTableDC ;			// 

public:
	struct	PARAMETER
	{
		REAL32			m_rYScaleDC ;			// Px̗ʎqW
		REAL32			m_rCScaleDC ;			// F̗ʎqW
		REAL32			m_rYScaleLow ;			// Pxg̗ʎqW
		REAL32			m_rCScaleLow ;			// Fg̗ʎqW
		REAL32			m_rYScaleHigh ;			// Pxg̗ʎqW
		REAL32			m_rCScaleHigh ;			// Fg̗ʎqW
		int				m_nLowThreshold ;		// Pxg臒l
		int				m_nHighThreshold ;		// Pxg臒l

		PARAMETER( void ) ;
	} ;
protected:
	PARAMETER			m_parameter ;			// kp[^

	static PFUNC_COLOR_OPRATION	m_pfnColorOperation[0x10] ;

public:
	// \z֐
	ERIEncoder( void ) ;
	// Ŋ֐
	virtual ~ERIEncoder( void ) ;

	// ip[^̐ݒj
	int Initialize( const ERI_INFO_HEADER & infhdr ) ;
	// IỉȂǁj
	void Delete( void ) ;
	// 摜k
	int EncodeImage
		( const RASTER_IMAGE_INFO & srcimginf,
			RLHEncodeContext & context, DWORD fdwFlags = 0x0021 ) ;
	// kIvVݒ
	void SetCompressionParameter( const PARAMETER & parameter ) ;

protected:
	// TvOe[ȕ
	void InitializeSamplingTable( void ) ;
	// tJ[摜̈k
	int EncodeTrueColorImage
		( const RASTER_IMAGE_INFO & imginf,
			RLHEncodeContext & context, DWORD fdwFlags ) ;
	// tJ[摜̈k
	int EncodeTrueColorImageII
		( const RASTER_IMAGE_INFO & imginf,
			RLHEncodeContext & context, DWORD fdwFlags ) ;
	// pbg摜̈k
	int EncodePaletteImage
		( const RASTER_IMAGE_INFO & imginf, RLHEncodeContext & context ) ;

	// 
	void DifferentialOperation( LONG nAllBlockLines, PINT * ptrNextLineBuf ) ;
	// Iy[VR[h擾
	DWORD DecideOperationCode
		( int nCompressMode, LONG nAllBlockLines, PINT * ptrNextLineBuf ) ;

	// `l̃rbg[x擾
	virtual int GetChannelDepth
		( DWORD fdwFormatType, DWORD dwBitsPerPixel ) ;
	// w̃rbg[xɃf[^𐳋K
	void NormalizeWithDepth( PINT ptrDst, PINT ptrSrc, int nCount ) ;
	// 摜TvO֐ւ̃|C^擾
	virtual PFUNC_SAMPLING GetSamplingFunc
		( DWORD fdwFormatType, DWORD dwBitsPerPixel ) ;

	// J[Iy[V֐Q
	void ColorOperation0000( void ) ;
	void ColorOperation0101( void ) ;
	void ColorOperation0110( void ) ;
	void ColorOperation0111( void ) ;
	void ColorOperation1001( void ) ;
	void ColorOperation1010( void ) ;
	void ColorOperation1011( void ) ;
	void ColorOperation1101( void ) ;
	void ColorOperation1110( void ) ;
	void ColorOperation1111( void ) ;

	// OC摜̃TvO
	void SamplingGray8
		( PBYTE ptrSrc, LONG nLineBytes, int nWidth, int nHeight ) ;
	// RGB摜(15rbg)̃TvO
	void SamplingRGB16
		( PBYTE ptrSrc, LONG nLineBytes, int nWidth, int nHeight ) ;
	// RGB摜̃TvO
	void SamplingRGB24
		( PBYTE ptrSrc, LONG nLineBytes, int nWidth, int nHeight ) ;
	// RGBA摜̃TvO
	void SamplingRGBA32
		( PBYTE ptrSrc, LONG nLineBytes, int nWidth, int nHeight ) ;

protected:
	// TvOe[ȕ
	void InitializeZigZagTable( void ) ;
	// tJ[摜̈k
	int EncodeTrueColorImageDCT
		( const RASTER_IMAGE_INFO & imginf,
			RLHEncodeContext & context, DWORD fdwFlags ) ;

	// 摜TvO֐ւ̃|C^擾
	virtual PFUNC_SAMPLINGII GetSamplingFuncII
		( DWORD fdwFormatType, DWORD dwBitsPerPixel ) ;

	// RGB摜̃TvO
	void SamplingRGB24II
		( REAL32 * ptrBuffer[], PBYTE ptrSrc,
			LONG nLineBytes, int nWidth, int nHeight ) ;
	// RGBA摜̃TvO
	void SamplingRGBA32II
		( REAL32 * ptrBuffer[], PBYTE ptrSrc,
			LONG nLineBytes, int nWidth, int nHeight ) ;
	// [̈Ɏwlݒ
	void FillOddArea
		( REAL32 * ptrBuffer, int nWidth, int nHeight, REAL32 rFill ) ;

	// RGB -> YUV ϊ֐
	void ConvertRGBtoYUV( void ) ;

	// 4:4:4 XP[O
	void BlockScaling444( void ) ;
	// 4:2:2 XP[O
	void BlockScaling422( void ) ;
	// 4:1:1 XP[O
	void BlockScaling411( void ) ;

	// DCT ϊ{
	void PerformDCT( void ) ;

	// ʎq{
	void ArrangeAndQuantumize( BYTE bytCoefficient[] ) ;

protected:
	// WJis󋵒ʒm֐
	virtual int OnEncodedBlock( LONG line, LONG column ) ;
	virtual int OnEncodedLine( LONG line ) ;

} ;

#define	ERI_ENCODE_INDEPENDENT_BLOCK	0x0001
#define	ERI_MAKE_COMPRESS_MODE(x)		(((x) & 0x03) << 4)
#define	ERI_GET_COMPRESS_MODE(x)		(((x) & 0x30) >> 4)



/*****************************************************************************
                     t@CXg[ReLXg
 *****************************************************************************/

class	EFileEncodeContext	: public	RLHEncodeContext
{
public:
	// \z֐
	EFileEncodeContext( EWriteFileObj * pFileObj, ULONG nBufferingSize ) ;
	// Ŋ֐
	virtual ~EFileEncodeContext( void ) ;

protected:
	EWriteFileObj *	m_pFileObj ;

public:
	// ̃f[^o
	virtual ULONG WriteNextData( const BYTE * ptrBuffer, ULONG nBytes ) ;
	// t@CIuWFNgݒ肷
	void AttachFileObject( EWriteFileObj * pFileObj ) ;

} ;


#endif
