//---------------------------------------------------------------------------
/*
	Risa [肳]      alias gg3 [kirikiri-3]
	 stands for "Risa Is a Stagecraft Architecture"
	Copyright (C) 2000 W.Dee <dee@kikyou.info> and contributors

	See details of license at "license.txt"
*/
//---------------------------------------------------------------------------
//! @file
//! @brief WaveZOg/xL[Ǘ
//---------------------------------------------------------------------------
#include "tjsCommHead.h"

#include "WaveSegmentQueue.h"


//---------------------------------------------------------------------------
void tTVPWaveSegmentQueue::Clear()
{
	Labels.clear();
	Segments.clear();
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
void tTVPWaveSegmentQueue::Enqueue(const tTVPWaveSegmentQueue & queue)
{
	Enqueue(queue.Labels); // Labels GL[(ɂȂƂ)
	Enqueue(queue.Segments); // segments L[(͌)
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
void tTVPWaveSegmentQueue::Enqueue(const tTVPWaveSegment & segment)
{
	if(Segments.size() > 0)
	{
		// ̃ZOg 1 ȏ゠
		tTVPWaveSegment & last = Segments.back();
		// Ō̃ZOgƂꂩǉ悤ƂZOgAĂ邩H
		if(last.Start + last.Length == segment.Start &&
			(double)last.FilteredLength / last.Length ==
			(double)segment.FilteredLength / segment.Length)
		{
			// AĂāAA䗦SɓȂ̂
			// ̍Ō̃ZOg
			// (Ȃ݂ɂŔ䗦̔r̍ۂɌ덷ƂĂ
			//  傫ȖƂ͂ȂȂ)
			last.FilteredLength += segment.FilteredLength;
			last.Length += segment.Length;
			return ; // 
		}
	}

	// PɍŌɗvfǉ
	Segments.push_back(segment);
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
void tTVPWaveSegmentQueue::Enqueue(const tTVPWaveLabel & Label)
{
	Labels.push_back(Label);
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
void tTVPWaveSegmentQueue::Enqueue(const std::deque<tTVPWaveSegment> & segments)
{
	// segment ̒ǉ
	for(std::deque<tTVPWaveSegment>::const_iterator i = segments.begin();
		i != segments.end(); i++)
		Enqueue(*i);
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
void tTVPWaveSegmentQueue::Enqueue(const std::deque<tTVPWaveLabel> & Labels)
{
	// ItZbgɉZl𓾂
	tjs_int64 Label_offset = GetFilteredLength();

	// Label ̒ǉ
	for(std::deque<tTVPWaveLabel>::const_iterator i = Labels.begin();
		i != Labels.end(); i++)
	{
		tTVPWaveLabel one_Label(*i);
		one_Label.Offset += Label_offset; // offset ̏C
		Enqueue(one_Label);
	}
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
void tTVPWaveSegmentQueue::Dequeue(tTVPWaveSegmentQueue & dest, tjs_int64 length)
{
	tjs_int64 remain;
	// dest NA
	dest.Clear();

	// Segments ؂o
	remain = length;
	while(Segments.size() > 0 && remain > 0)
	{
		if(Segments.front().FilteredLength <= remain)
		{
			// Segments.front().FilteredLength  remain ȉ
			//  ̗vf dest ɃGL[ this 폜
			remain -= Segments.front().FilteredLength;
			dest.Enqueue(Segments.front());
			Segments.pop_front();
		}
		else
		{
			// Segments.front().FilteredLength  remain 傫
			//  vfrłԂ dest ɃGL[
			// FilteredLength ɐ؂osĂ̂
			// Length  `Ԃs
			tjs_int64 newlength =
				static_cast<tjs_int64>(
					(double)Segments.front().Length / (double)Segments.front().FilteredLength * remain);
			if(newlength > 0)
				dest.Enqueue(tTVPWaveSegment(Segments.front().Start, newlength, remain));

			// Segments.front()  Start, Length  FilteredLength C
			Segments.front().Start += newlength;
			Segments.front().Length -= newlength;
			Segments.front().FilteredLength -= remain;
			if(Segments.front().Length == 0 || Segments.front().FilteredLength == 0)
			{
				// Ԃ؂ (`⊮ʂ̌덷)
				// 0ɂȂĂ܂
				Segments.pop_front(); // ZOĝĂ
			}
			remain = 0; // [v𔲂
		}
	}

	// Labels ؂o
	size_t Labels_to_dequeue = 0;
	for(std::deque<tTVPWaveLabel>::iterator i = Labels.begin();
		i != Labels.end(); i++)
	{
		tjs_int64 newoffset = i->Offset - length;
		if(newoffset < 0)
		{
			// newoffset  Ȃ̂ dest ɓ
			dest.Enqueue(*i);
			Labels_to_dequeue ++; // Ƃ dequeue
		}
		else
		{
			// *i ̃ItZbgC
			i->Offset = newoffset;
		}
	}

	while(Labels_to_dequeue--) Labels.pop_front(); // Rs[Labels 폜
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
tjs_int64 tTVPWaveSegmentQueue::GetFilteredLength() const
{
	// L[̒ ׂĂ Segments FilteredLength̍v
	tjs_int64 length = 0;
	for(std::deque<tTVPWaveSegment>::const_iterator i = Segments.begin();
		i != Segments.end(); i++)
		length += i->FilteredLength;

	return length;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
void tTVPWaveSegmentQueue::Scale(tjs_int64 new_total_filtered_length)
{
	// L[ FilteredLength ω
	tjs_int64 total_length_was = GetFilteredLength(); // ωO̒

	if(total_length_was == 0) return; // ̒Ȃ̂ŃXP[oȂ

	// Segments ̏C
	tjs_int64 offset_was = 0; // ωÕItZbg
	tjs_int64 offset_is = 0; // ω̃ItZbg

	for(std::deque<tTVPWaveSegment>::iterator i = Segments.begin();
		i != Segments.end(); i++)
	{
		tjs_int64 old_end = offset_was + i->FilteredLength;
		offset_was += i->FilteredLength;

		// old_end ͑Ŝ猩Ăǂ̈ʒuɂH
		double ratio = static_cast<double>(old_end) /
						static_cast<double>(total_length_was);

		// V old_end ͂ǂ̈ʒuɂׂH
		tjs_int64 new_end = static_cast<tjs_int64>(ratio * new_total_filtered_length);

		// FilteredLength ̏C
		i->FilteredLength = new_end - offset_is;

		offset_is += i->FilteredLength;
	}

	// ۂSegments ̏
	for(std::deque<tTVPWaveSegment>::iterator i = Segments.begin();
		i != Segments.end() ; )
	{
		if(i->FilteredLength == 0 || i->Length == 0)
			i = Segments.erase(i);
		else
			i++;
	}

	// Labels ̏C
	double ratio = (double)new_total_filtered_length / (double)total_length_was;
	for(std::deque<tTVPWaveLabel>::iterator i = Labels.begin();
		i != Labels.end(); i++)
	{
		i->Offset = static_cast<tjs_int64>(i->Offset * ratio);
	}
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
tjs_int64 tTVPWaveSegmentQueue::FilteredPositionToDecodePosition(tjs_int64 pos) const
{
	// Segments ̏C
	tjs_int64 offset_filtered = 0;

	for(std::deque<tTVPWaveSegment>::const_iterator i = Segments.begin();
		i != Segments.end(); i++)
	{
		if(offset_filtered <= pos && pos < offset_filtered + i->FilteredLength)
		{
			// ΉԂ̂Ő`ŕ⊮ĕԂ
			return (tjs_int64)(i->Start + (pos - offset_filtered) *
				(double)i->Length / (double)i->FilteredLength );
		}

		offset_filtered += i->FilteredLength;
	}

	// ΉԂȂ̂ŁA炩ɕł 0 A
	// łȂ΍Ō̈ʒuԂ
	if(pos<0) return 0;
	if(Segments.size() == 0) return 0;
	return Segments[Segments.size()-1].Start + Segments[Segments.size()-1].Length;
}
//---------------------------------------------------------------------------


